const staticRouter: AppCustomRouteRecordRaw[] = [
  {
    icon: 'ep:calendar',
    path: '/Okr',
    component: '',
    name: 'OKR',
    componentName: '',
    redirect: '',
    parentId: 0,
    visible: true,
    alwaysShow: true,
    children: [
      {
        icon: 'ep:finished',
        path: 'okr-management',
        name: 'OKR管理',
        componentName: 'OkrManagement',
        component: 'OKR/Management/index',
        visible: true,
        alwaysShow: true,
        meta: {
          title: 'OKR管理'
        },
        redirect: ''
      },
      {
        icon: 'ep:alarm-clock',
        path: 'okr-wait',
        name: '待办事项',
        componentName: 'OkrWait',
        component: 'OKR/Wait/index',
        meta: {
          title: '待办事项'
        },
        visible: true,
        alwaysShow: true,
        redirect: ''
      }
    ],
    meta: {
      title: 'OKR',
      icon: 'ep:calendar'
    }
  }
]

export default staticRouter
